package main

import (
  "fmt"
  "http"
  "io"
  "os"
  "template" )

func formHandler(response http.ResponseWriter, request *http.Request) {

  // ファイルをオープン
  file, err := os.Open("form.html", os.O_RDONLY, 0)
  if err != nil {
    panic(err)
  }

  defer file.Close()

  // ファイルの内容をresponseに書き出す
  _, err = io.Copy(response, file)
  if err != nil {
    panic(err)
  }
}

func helloHandler(response http.ResponseWriter, request *http.Request) {

  // パラメータ（入力フォームに入力された文字列）取得
  who := request.FormValue("who")

  // テンプレートに適用するために、パラメータをmap型で格納
  param := map[string] string {"who" : who}

  // テンプレートの読み込み
  tmpl, err := template.ParseFile("hello.html", nil)
  if err != nil {
    http.Error(response, "テンプレートエラー",
      http.StatusInternalServerError)
    return
  }

  // テンプレートにパラメータを適用し、responseに書き出す
  tmpl.Execute(param, response)
}

func main() {

  http.HandleFunc("/", formHandler)

  http.HandleFunc("/hello", helloHandler)
  
  err := http.ListenAndServe(":8080", nil)
  if err != nil {
    fmt.Println(err)
  }
}

